* TEST.PRG for PDFListener
* with instructions on use
* of some optional features.
* See README.TXT for more information.

* NB: use the GSLOCATION member
* property to set a path with 
* no spaces unless you are using
* a copy of PDFLISTENER.PRG fixed
* (6/15/2005) to handle this properly.

* (c) Lisa Slater Nicholls >L<

#DEFINE PICKREPORT_LOC "Add a report with NO PrinterEnv saved (or ESC to finish)..."
#DEFINE PDFAVAILABLE_LOC thisPDF.TargetFileName + " is now available."
#DEFINE ERRORPREFIX_LOC "ERROR: "

EXTERNAL TABLE Install.DBF

LOCAL loX, lcDir

lcDir = SET("DIRECTORY")
CD (JUSTPATH(SYS(16,0)))
loX = CREATEOBJECT("test")
loX.Run()
CD (lcDir)
RETURN


DEFINE CLASS Test AS Custom

    outputFile = SYS(2015)
    oldStyle = .T.
    showPDF = .T.
    removeReportsAfterRun = .T.
    
    PROCEDURE Run
       LOCAL thisPDF, cReport, lRun, cpass

       thisPDF = NEWOBJECT("pdflistener","pdflistener.prg")
       * where you want ghostscript files to be 
       * installed (all tempfiles will go here too)
       thisPDF.GSLOCATION = ADDBS(FULLPATH(".\GS"))
       * where you want the result
       thisPDF.targetFileName = FORCEPATH(THIS.outputFile,SET("DIRECTORY"))
       * what you want the driver name to look like in Windows
       thisPDF.PSDRIVERSETUPNAME = "My Application PDF"


     * change other attributes, such as:
     * thisPDF.RETAINTEMPFILES = .T.  && will go into the recycle bin    
     * thisPDF.throwOLEError = .T.  && only takes effect if in a COM object
     * thispdf.QuietMode = .T.    && you don't even want to see status msgs

      IF THIS.oldStyle THEN
         thisPDF.generateNewStyleOutput = .F.
      ELSE
         thisPDF.generateNewStyleOutput = .T.
      ENDIF

      WAIT WINDOW NOWAIT PICKREPORT_LOC
      
      cReport = GETFILE("FRX")
      
      DO WHILE NOT EMPTY(cReport)
         lRun = .T.
         thisPDF.addReport(cReport)
         * NB: you can add explicit clauses:
         * thisPDF.addReport(cReport"," NEXT 1") && etc
         * and you can add an explicit ReportListener reference
         * to handle the report.  These references do not have
         * to be to the same listener.  If you do not add
         * explicit reference but generateNewStyleOutput,
         * pdfListener uses a THIS reference here.
         * It is your responsibility to set ListenerType appropriately
         * and scope appropriately, if you use explicit Listener object references.
         * THIS.addReport(cReport," OBJECT oListener " )
         * or
         * THIS.addReport(cReport,"",oListener)     
         WAIT WINDOW NOWAIT PICKREPORT_LOC
         cReport = GETFILE("FRX")
      ENDDO
      
      WAIT CLEAR
      
      IF lRun THEN

         thisPDF.runReports(this.removeReportsAfterRun, this.oldStyle)
         * runReports arguments: tlRemoveReportsAfterRun, tlOmitListenerReferences
         IF LEN(thisPDF.GetLastErrorMessage()) > 0 THEN
            MESSAGEBOX(ERRORPREFIX_LOC+ thisPDF.GetLastErrorMessage())
         ELSE
            IF this.ShowPDF
               DECLARE INTEGER ShellExecute ;
                   IN SHELL32.DLL ;
                   INTEGER nWinHandle,;
                   STRING cOperation,;   
                   STRING cFileName,;
                   STRING cParameters,;
                   STRING cDirectory,;
                   INTEGER nShowWindow
               ShellExecute(0,"Open",thisPDF.targetFilename,"","",1)
               CLEAR DLLS ShellExecute
            ELSE
               MESSAGEBOX(PDFAVAILABLE_LOC)  
            ENDIF   
         ENDIF
         
      ENDIF   
      
   ENDPROC

ENDDEFINE   